import { csv, descending } from 'd3';

const csvUrl =
  'https://gist.githubusercontent.com/curran/d5f3acd14d38125e98c49634e6dd05d7/raw/2eee2ed580790066cf90df7054faed80aa90793d/Data.csv';

const countryTotals = {}

export const getData = async () => {
  const data = (await csv(csvUrl))
    .filter(d => d['2018 [YR2018]'] !== '..')
    .filter(d => d['Series Name'] !== 'Manufactures exports (% of merchandise exports)')
    .map(d => {
      d.value = +d['2018 [YR2018]'];
      if(!countryTotals[d['Country Name']]){
        countryTotals[d['Country Name']] = 0;
      }
      countryTotals[d['Country Name']] += d.value;
      return d;
    });
  
  const topCountries = {};
  
  Object.entries(countryTotals)
    .map(([country, total]) => ({country, total}))
    .sort((a, b) => descending(a.total, b.total))
    .slice(0, 10)
    .forEach(d => topCountries[d.country] = true);
  
  const topData = data.filter(d => topCountries[d['Country Name']]);
  
  console.log(topData);

  // Have a look at the attributes available in the console!
  console.log(data[0]);

  return topData;
};
